# SoVRMLNormalInterpolator Class Reference
[VRML97 classes]

`#include <Inventor/VRMLnodes/SoVRMLNormalInterpolator.h>`

Inheritance diagram for SoVRMLNormalInterpolator:

List of all members.

## Detailed Description

The SoVRMLNormalInterpolator class is used to interpolate normals.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

      NormalInterpolator {
        eventIn      SFFloat set_fraction       # (-inf, inf)
        exposedField MFFloat key           []   # (-inf, inf)
        exposedField MFVec3f keyValue      []   # (-inf, inf)
        eventOut     MFVec3f value_changed
      }

The NormalInterpolator node interpolates among a list of normal vector sets specified by the keyValue field. The output vector, value_changed, shall be a set of normalized vectors. Values in the keyValue field shall be of unit length. The number of normals in the keyValue field shall be an integer multiple of the number of keyframes in the key field. That integer multiple defines how many normals will be contained in the value_changed events. Normal interpolation shall be performed on the surface of the unit sphere. That is, the output values for a linear interpolation from a point P on the unit sphere to a point Q also on the unit sphere shall lie along the shortest arc (on the unit sphere) connecting points P and Q. Also, equally spaced input fractions shall result in arcs of equal length. The results are undefined if P and Q are diagonally opposite. A more detailed discussion of interpolators is provided in 4.6.8, Interpolator nodes (<http://www.web3d.org/technicalinfo/specifications/vrml97/part1/concepts.html#4.6.8>).

## Public Member Functions

| SoVRMLNormalInterpolator (void)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoMFVec3f | keyValue
SoEngineOutput | value_changed

## Protected Member Functions

virtual | ~SoVRMLNormalInterpolator ()

## Constructor & Destructor Documentation

SoVRMLNormalInterpolator::SoVRMLNormalInterpolator | ( | void |  | ) |

| Constructor.

SoVRMLNormalInterpolator::~SoVRMLNormalInterpolator | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLNormalInterpolator::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoVRMLInterpolator.

## Member Data Documentation

SoMFVec3f SoVRMLNormalInterpolator::keyValue

| The keyValue vector.

SoEngineOutput SoVRMLNormalInterpolator::value_changed

| The eventOut which is sent every time the interpolator has calculated a new value.

The documentation for this class was generated from the following files:

- SoVRMLNormalInterpolator.h
- NormalInterpolator.cpp